/* The Guessing Game by Redbluefire */
/* Include all the required stuff */
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdlib.h>
#include <string.h>
/* Give it a name (the real name is defined in the 
   makefile, this just helps insure backwards compatibility) */
PSP_MODULE_INFO("Guessing Game", 0, 1, 1);
/* Define printf to make text easier */
#define printf pspDebugScreenPrintf

 /* Essential stuff */
 /* Exit callback */
int exit_callback(int arg1, int arg2, void *common) {
          sceKernelExitGame();
          return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp) {
          int cbid;

          cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
          sceKernelRegisterExitCallback(cbid);

          sceKernelSleepThreadCB();

          return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void) {
          int thid = 0;

          thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
          if(thid >= 0) {
                    sceKernelStartThread(thid, 0, 0);
          }

          return thid;
}

/* End of the Essential Stuff */


/* Function thanks to cyberbill to find a random number between two numbers */
int Rando(int min, int max)
             {   
              /* Seed rand() with the clock time to give the appearance of randomness */
              srand(sceKernelLibcTime(NULL));
              int Diff = max - min;
              return (rand() % Diff)+min;
             }


/* Main Code, PSP executes this first from the top-down */
int main(void)
              {
              	SceCtrlData pad;
                // Define variables, such as the random number for the game
                int random = Rando(1, 1000);
              	int pickg = 0;
                int guess = 0;
                // Start up the Debug Screen
                pspDebugScreenInit();
	            // Activate the controls
                SetupCallbacks();
             	sceCtrlSetSamplingCycle(0);
              	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
                while(1){
                         // Set it up to read the Controls
                         sceCtrlReadBufferPositive(&pad, 1);
                                // Position the "The gussing Game!" Text
                                pspDebugScreenSetXY(1, 0);
                                printf("The guessing Game!");
                                // Position the text that tells us our guess
                                pspDebugScreenSetXY(2, 3);
                                /* Use %4i to pad the number guessed so no junk
                                   is left behind when it changes digit length */
                                printf("Your guess is %4i", guess);
                                /* Increase the guess by one when pressing up, but only 
                                   when the guess is under one thousand, so the guess never 
                                   goes over one thousand. */
                                if ((pad.Buttons & PSP_CTRL_UP) && (guess < 1000)){
                                                guess++;}
                                /* Decrease the guess by one when pressing down, but 
                                   only when the guess is above zero, so it never goes 
                                   below zero. */
                                if ((pad.Buttons & PSP_CTRL_DOWN) && (guess > 0)){
                                                guess--;}
                                /* Decrease the guess by ten when presing the L trigger, 
                                   but only when the guess is above ten, so the guess 
                                   never goes under zero. */
                                if ((pad.Buttons & PSP_CTRL_LTRIGGER) && (guess > 10)){
            			        	guess -= 10;}
                                /* Increase the guess by ten when presing the R trigger, 
                                   but only when the guess is under nine hundred and 
                                   ninety, so the guess never goes over one thousand. */
                                if ((pad.Buttons & PSP_CTRL_RTRIGGER) && (guess < 990)){
      	                            guess += 10;}
   	                            /* Change the number the program checks against to the 
                                   currently visible number when cross is pressed */
                                if (pad.Buttons & PSP_CTRL_CROSS){
			                    	pickg = guess;
		                      	} 
                                           
                         
                         // Position the clue text
                         pspDebugScreenSetXY(6, 7);
                         /* Figure out what clue to give you, depending on whether 
                            your guess is higher or lower than the number */
                         if (pickg > random)
                         { printf("Lower!!"); }
                         if (pickg < random)
                         { printf("Higher!"); }
                         // Tell you you're a winner if your guess is right
                         if (pickg == random)
                         { printf("Winner!"); 
                           // Pause the game and wait for the home button to be used to exit
                           sceKernelSleepThread();
                         }
               }
	sceKernelExitGame();
	return 0;
}
